#declare clothes = texture
{
        pigment
        {
                color rgb< 0.5, 0.2, 0.7 >
        }
        normal    
	{
		granite 0.05
		frequency 6
	}
        finish
        {
                diffuse 0.8
                ambient 1.5
        }
}

#declare white_clothes = texture
{
        pigment
        {
                bozo
                color_map
                {
                        [ 1.0 color rgb< 1.0, 1.0, 1.0 >]
                        [ 0.5 color rgb< 0.5, 0.5, 0.5 >]
                }
                turbulence 1.0
        }
        finish
        {
                ambient 0.7
        }
        normal
        {
                bumps 1
                scale 0.01
        }
}

#declare skin = texture
{
        pigment
        {
                color rgb< 1.0, 0.7, 0.5 >
        }
        normal
        { 
                bumps 0.009
                scale 0.0001
        }
        finish
        {
                diffuse 0.8
                phong 0.1
                ambient 2.0
        }
}

#declare lips = texture
{
        pigment
        {
                color rgb< 0.5, 0.2, 0.1 >
        }
        finish
        {
                phong 0.5
        }
}

#declare eye_color = texture
{
        pigment
        {
                color rgb< 0.0, 0.2, 0.5 >
        }
}

#declare eye_back = texture
{
        pigment
        {
                color rgb< 10, 10, 10 >
        }
}

#declare glass = texture
{
        pigment
        {
                color rgbt< 1, 1, 1, 0.8 >
        }
        finish
        {
                reflection 0.2
                phong 0.8
        }
        normal
        {
                bumps
                bump_size 0.002
                scale 0.1
        }
}

#declare wall_texture = texture
{
        pigment
        {
                color rgb< 1.25, 1.25, 1.25 >
        }
        normal
        {
                agate
                bump_size 0.1
                scale 0.005
        }
        finish
        {
                ambient 2.0
        }
}

#declare brick_pigment = pigment
{
        agate
        color_map
        {
                [0.0 color rgb< 0.5, 0.1, 0.1 > ]
                [0.7 color rgb< 0.6, 0.1, 0.1 > ]
                [0.8 color rgb< 1.0, 0.2, 0.2 > ]
        }
        turbulence 1
        lambda 20
}

#declare mortar_pigment = pigment
{
        color rgb< 1.0, 1.0, 1.0 >
}

#declare rough_wall = texture
{
        pigment
        {
                brick pigment{ mortar_pigment}, pigment{ brick_pigment }
                scale 0.01
        }
        normal
        {
                brick
                bump_size 0.1
                scale 0.01
        }
}

#declare black = texture
{
        pigment
        {
                bozo
                color_map
                {
                        [1.0 color rgb< 0.2, 0.2, 0.2 > ]
                        [1.0 color rgb< 0.0, 0.0, 0.0 > ]
                }
        }
}

#declare chimney_wall = texture
{
        agate
        texture_map
        {
                [0.0 wall_texture]
                [0.2 black ]
                [1.0 rough_wall]
        }
}


#declare roof_texture = texture
{
        pigment 
	{
		rgb <1.35, 1.45, 1.5>
	} 
	normal    
	{
		granite 0.05
		frequency 60000
		//scale 20
	}   
	finish 
	{
		ambient 0.5
		diffuse 0.5
		roughness 1 
		phong 0.07 
		specular 0.2
	}     

}

#declare wood_board = texture
{
        pigment
        {
                wood
                color_map
                { 
                        [0.0, 0.1 color rgb <0.9, 0.6, 0.4>color rgb <0.9, 0.6, 0.4>]
                        [0.1, 0.9 color rgb <0.9, 0.6, 0.4>color rgb <0.6, 0.3, 0.2>]
                        [0.9, 1.0 color rgb <0.3, 0.15, 0.1>color rgb <0.3 0.15, 0.1>]
                }
                turbulence 0.2

        }
        normal
        {
                wood
                turbulence 0.2
        }
        finish
        {
                diffuse 1.0
                phong 0.1
        }
}

#declare colored_board = texture
{
        pigment
        {
                color rgb< 0.8, 0.7, 0.0 >
        }
        normal
        {
                wood
                turbulence 0.2
                bump_size 0.05
        }
        finish
        {
                diffuse 1.0
                phong 0.8
        }
}

#declare window_frame = texture
{
        bozo
        texture_map
        {
                [0.0 wood_board]
                [0.3 colored_board]
        }
        turbulence 0.3
}

#declare window_board = texture
{
        pigment
        {
                agate
                color_map
                {
                        [ 0.0 rgb < 0.3, 0.3, 0.3 > ]
                        [ 0.1 rgb < 0.7, 0.7, 0.7 > ]
                        [ 0.2 rgb < 0.9, 0.9, 0.9 > ]
                        [ 1.0 rgb < 1.0, 1.0, 1.0 > ]
                }
                scale <0.2, 0.2, 0.2>
        }
        finish
        {
                phong 1.0
                reflection 0.1
                diffuse 0.5
        }
        normal
        {
                bumps
                bump_size 0.5
                scale 0.05
        }
}

#declare iron = texture
{
        pigment
        {
                color rgb< 0.7, 0.9, 1.0 >
        }
        finish
        {
                reflection 0.1
                phong 3.0
                ambient 1.0
        }
        normal
        {
                dents
                bump_size 0.5
                scale 0.01
        }
}

#declare rust = texture
{
        pigment
        {
                bozo
                color_map
                {
                        [0.0 color rgb< 1.0, 0.5, 0.2>]
                        [1.0 color rgb< 0.5, 0.2, 0.0>]
                }
                turbulence 0.8
                lambda 0.55
         }
         normal
         {
                bumps
                bump_size 0.5
                scale 0.01
         }
}

#declare drain_metal = texture
{
        bozo
        texture_map
        {
                [0.0 rust]
                [0.5 iron]
        }
        turbulence 1 
        lambda 55
}

#declare snow_texture = texture
{
	pigment 
	{
		rgb <1.30, 1.40, 1.45>
	} 
	normal    
	{
		granite 0.05
		frequency 60000
		//scale 20
	}   
	finish 
	{
		ambient 2.5
		diffuse 0.5
		roughness 1 
		phong 0.07 
		specular 0.2
	}     
}

#declare ice_texture = texture
{
	pigment 
	{
		rgb <1.30, 1.40, 1.45>
	} 
	normal    
	{
		granite 0.05
		frequency 600
	}   
	finish 
	{
		ambient 2.5
		diffuse 0.5
		phong 0.07 
		specular 0.2
	}                
}

#declare sky_texture = texture
{
        pigment
        {
                bozo
                color_map
                {
                        [ 0.0 color rgbt< 1, 1, 1, 0.5 >]
                        [ 0.8 color rgbt< 1, 1, 1, 0.8 >]
                        [ 1.0 color rgbt< 1, 1, 1, 1.0 >]
                }
                turbulence 8
                lambda 5
        }
        finish
        {
                ambient 5
        }
} 

#declare mountains = texture
{
	slope y, y, <0.3, 1>, <0, 4>
	texture_map 
	{ 
		[0.2 black]
		[0.2 snow_texture]       
	}
}

#declare bavarian_flag = texture
{
        pigment
        {
                checker pigment{ color rgb< 2, 2, 2 > },pigment{ color rgb< 0, 0, 1 > }
                rotate< 45, 0, 0 >
                scale< 2, 5, 2 >
                rotate< 45, 0, 0 >
        }
        normal
        {
                ripples
                bump_size 2
                scale< 5, 5, 5 >
                turbulence 0.5
        }
}     

#declare moon_map = texture
{
        pigment
        {       
                image_map
                { 
                        png "moonmap" 
                        map_type 1
                }
        } 
        normal
        {
                bump_map
                { 
                        png "moonbump"
                        map_type 1
                        bump_size 1.5
                } 
        }   
}

#declare atmosphere_material = material
{
        texture
        {
                pigment
                {
                        color rgbt <1.0,1.0,1.0,1.0>
                }
        }
        interior
        {
                media
                {
                        scattering
                        { 
                                    1
                                    rgb<2, 3, 5>
                                    extinction 0
                        }
                        density
                        {
                                spherical
                                color_map
                                {
                                        [ 0.0  rgb <0.0, 0.0, 0.0> ]
                                        //[ 0.002  rgb <0.01, 0.01, 0.01> ]
                                        //[ 0.003  rgb <0.4, 0.4, 0.4> ]
                                        //[ 0.010  rgb <0.6, 0.6, 0.6> ]
                                        [ 2000  rgb <1.0, 1.0, 1.0> ]
                                }
                        }
                }
        }
}

#declare steam_material = material
{
        texture
        {
                pigment
                {
                        color rgbt <1.0,1.0,1.0,1.0>
                }
        }
        interior
        {
                media
                {
                        scattering
                        { 
                                    2
                                    rgb<5, 5, 5>
                                    extinction 0
                        }
                        density
                        {
                                spherical
                                color_map
                                {
                                        [ 0.0  rgb <0.0, 0.0, 0.0> ]
                                        [ 0.8  rgb <1.0, 1.0, 1.0> ]
                                }
                                turbulence 1.0
                                lambda 8.0
                        }
                }
        }
}

#declare fog_material = material
{
        texture
        {
                pigment
                {
                        color rgbt< 1.0, 1.0, 1.0, 1.0 >
                }
        }
        interior
        {
                media
                {
                        scattering
                        {
                                2
                                rgb< 5, 5, 5 >
                                extinction 1
                        }
                        density
                        {
                                spherical
                                color_map
                                {
                                        [ 0.0 rgb <0.0, 0.0, 0.0> ]
                                        [ 1000 rgb <1.5, 1.5, 1.5> ]
                                }
                        }
                 }
       }       
}

#declare smoke_material = material
{
        texture
        {
                pigment
                {
                        color rgbt <1.0,1.0,1.0,1.0>
                }
        }
        interior
        {
                media
                {
                        scattering
                        { 
                                    3
                                    rgb<0.5, 0.5, 0.5>
                                    extinction 1.0
                        }
                        absorption rgb <0.3, 0.3, 0.3>
                        density
                        {
                                spherical
                                color_map
                                {
                                        [ 0.5  rgb <0.0, 0.0, 0.0> ]
                                        [ 0.51 rgb <5.0, 5.0, 5.0> ]
                                }
                                turbulence 0.4
                                omega 0.8
                                triangle_wave
                        }
                }
        }
}

